#include <stdio.h>
#include <stdlib.h>
#include <dirent.h>

#include <Fl/Fl_Window.H>
#include <Fl/Fl_Browser.H>
#include <Fl/Fl_Input.H>

// ***********************************************************
extern Fl_Window *fbShowFile;
extern Fl_Browser *fbDirWindow, *fbSFWindow;
extern Fl_Input *fbDirectory;

struct dirent **dnl;
DIR *dir;

int i,j,k;
char buf[256], debug = 1;
char bf[256];

// ***********************************************************
int processDir(char *d) {
if (debug == 1) printf("pD: %s\n", d);
	if (d == NULL) {
		i=scandir(fbDirectory->value(), &dnl, 0, alphasort);
	} else {
		i=scandir(d, &dnl, 0, alphasort);
	}
//	can the dir be opened ?
	if (i < 1) {
		return 0;
	}

	fbDirWindow->clear();
// add each entry to the browser
	for (j=0; j < i; j++) {
if (debug == 1) printf("pD: %s (%d)\n", dnl[j]->d_name, dnl[j]->d_type);
		switch(dnl[j]->d_type) {
			case DT_DIR: sprintf(buf, "%s/", dnl[j]->d_name);
							 fbDirWindow->add(buf);
							 break;
	// is the sym-link or unknown type a file or dir ?
			case DT_UNKNOWN:
			case DT_LNK: sprintf(buf, "%s/%s", fbDirectory->value(), dnl[j]->d_name);
							 if ((dir = opendir(buf)) == NULL) {
								fbDirWindow->add(dnl[j]->d_name);
							 } else {
								closedir(dir);
								sprintf(buf, "%s/", dnl[j]->d_name);
								fbDirWindow->add(buf);
							 }
if (debug == 1) printf("pDt: %s (%d)\n", dnl[j]->d_name, dnl[j]->d_type);
							 break;
			default: 	 fbDirWindow->add(dnl[j]->d_name);
							 break;
		}
	}
	return i;
}

void selectItem() {
	i = fbDirWindow->value()-1;
	strcpy(bf, fbDirWindow->text(i));
	j = strlen(bf);
	k = strlen(fbDirectory->value());

	switch (bf[j-1]) {
		case '/':
					if (k == 1) {
						sprintf(bf, "/%s", dnl[i]->d_name);
					} else {
						sprintf(bf, "%s/%s", fbDirectory->value(), dnl[i]->d_name);
					}
					break;
		default:
					sprintf(bf, "%s/%s", fbDirectory->value(), dnl[i]->d_name);
					fbSFWindow->load(bf);
					fbShowFile->show();
					break;
	}
if (debug == 1) printf("sI: %s (%d/%d)\n", bf, fbDirWindow->value(), i);
	k = processDir(bf);
	if (k != 0) {
		fbDirectory->value(bf);
	}
}
